//this file is part of eMule
//Copyright (C)2002-2008 Merkur ( strEmail.Format("%s@%s", "devteam", "emule-project.net") / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "UploadListCtrl.h"
#include "TransferWnd.h"
#include "otherfunctions.h"
#include "MenuCmds.h"
#include "ClientDetailDialog.h"
#include "KademliaWnd.h"
#include "emuledlg.h"
#include "friendlist.h"
#include "MemDC.h"
#include "KnownFile.h"
#include "SharedFileList.h"
#include "UpDownClient.h"
#include "ClientCredits.h"
#include "ChatWnd.h"
#include "kademlia/kademlia/Kademlia.h"
#include "kademlia/net/KademliaUDPListener.h"
#include "UploadQueue.h"
#include "ToolTipCtrlX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// CUploadListCtrl

IMPLEMENT_DYNAMIC(CUploadListCtrl, CMuleListCtrl)

BEGIN_MESSAGE_MAP(CUploadListCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_WM_SYSCOLORCHANGE()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMDblclk)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnGetDispInfo)
	ON_NOTIFY_REFLECT(LVN_GETINFOTIP, OnLvnGetInfoTip)
END_MESSAGE_MAP()

CUploadListCtrl::CUploadListCtrl()
	: CListCtrlItemWalk(this)
{
	m_tooltip = new CToolTipCtrlX;
	SetGeneralPurposeFind(true, false);
}

void CUploadListCtrl::Init()
{
	SetName(_T("UploadListCtrl"));

	CImageList ilDummyImageList; //dummy list for getting the proper height of listview entries
	ilDummyImageList.Create(1, theApp.GetSmallSytemIconSize().cy,theApp.m_iDfltImageListColorFlags|ILC_MASK, 1, 1); 
	SetImageList(&ilDummyImageList, LVSIL_SMALL);
	ASSERT( (GetStyle() & LVS_SHAREIMAGELISTS) == 0 );
	ilDummyImageList.Detach();

	SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP);

	CToolTipCtrl* tooltip = GetToolTips();
	if (tooltip){
		m_tooltip->SubclassWindow(tooltip->m_hWnd);
		tooltip->ModifyStyle(0, TTS_NOPREFIX);
		tooltip->SetDelayTime(TTDT_AUTOPOP, 20000);
		tooltip->SetDelayTime(TTDT_INITIAL, thePrefs.GetToolTipDelay()*1000);
	}

	InsertColumn(0,GetResString(IDS_QL_USERNAME),LVCFMT_LEFT,150,0);
	InsertColumn(1,GetResString(IDS_FILE),LVCFMT_LEFT,275,1);
	InsertColumn(2,GetResString(IDS_DL_SPEED),LVCFMT_LEFT,60,2);
	InsertColumn(3,GetResString(IDS_DL_TRANSF),LVCFMT_LEFT,65,3);
	InsertColumn(4,GetResString(IDS_WAITED),LVCFMT_LEFT,60,4);
	InsertColumn(5,GetResString(IDS_UPLOADTIME),LVCFMT_LEFT,60,5);
	InsertColumn(6,GetResString(IDS_STATUS),LVCFMT_LEFT,110,6);
	InsertColumn(7,GetResString(IDS_UPSTATUS),LVCFMT_LEFT,100,7);
	InsertColumn(8,GetResString(IDS_UPSLOTNUMBER),LVCFMT_LEFT,100,8);
	InsertColumn(9,GetResString(IDS_SOFTWARE_LABEL),LVCFMT_LEFT,100,9);
	InsertColumn(10,GetResString(IDS_MODVERSION_LABEL),LVCFMT_LEFT,100,10);
	InsertColumn(11,GetResString(IDS_CHUNK),LVCFMT_LEFT,100,16);

	// <CB Mod : UploadListInfo>
#ifdef CB_MOD_EXTRAINFO_ENABLED
	InsertColumn(12,GetResString(IDS_DL_SIZE),LVCFMT_LEFT,100,12);
	InsertColumn(13,GetResString(IDS_IPNUMBER),LVCFMT_LEFT,100,13);
	InsertColumn(14,GetResString(IDS_UPLOADCONDITIONS),LVCFMT_LEFT,100,14);
#endif
	// </CB Mod : UploadListInfo>

	SetAllIcons();
	Localize();
	LoadSettings();

	// Barry - Use preferred sort order from preferences
	SetSortArrow();
	SortItems(SortProc, GetSortItem() + (GetSortAscending() ? 0:100));
}

CUploadListCtrl::~CUploadListCtrl()
{
	delete m_tooltip;
}

void CUploadListCtrl::OnSysColorChange()
{
	CMuleListCtrl::OnSysColorChange();
	SetAllIcons();
}

void CUploadListCtrl::SetAllIcons()
{
	imagelist.DeleteImageList();
	imagelist.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
	imagelist.SetBkColor(CLR_NONE);
	imagelist.Add(CTempIconLoader(_T("ClientEDonkey")));
	imagelist.Add(CTempIconLoader(_T("ClientCompatible")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientCompatiblePlus")));
	imagelist.Add(CTempIconLoader(_T("Friend")));
	imagelist.Add(CTempIconLoader(_T("ClientMLDonkey")));
	imagelist.Add(CTempIconLoader(_T("ClientMLDonkeyPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyHybrid")));
	imagelist.Add(CTempIconLoader(_T("ClientEDonkeyHybridPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientShareaza")));
	imagelist.Add(CTempIconLoader(_T("ClientShareazaPlus")));
	imagelist.Add(CTempIconLoader(_T("ClientAMule")));
	imagelist.Add(CTempIconLoader(_T("ClientAMulePlus")));
	imagelist.Add(CTempIconLoader(_T("ClientLPhant")));
	imagelist.Add(CTempIconLoader(_T("ClientLPhantPlus")));
	imagelist.SetOverlayImage(imagelist.Add(CTempIconLoader(_T("ClientSecureOvl"))), 1);
	imagelist.SetOverlayImage(imagelist.Add(CTempIconLoader(_T("OverlayObfu"))), 2);
	imagelist.SetOverlayImage(imagelist.Add(CTempIconLoader(_T("OverlaySecureObfu"))), 3);
}

void CUploadListCtrl::Localize()
{
	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	CString strRes;

	strRes = GetResString(IDS_QL_USERNAME);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(0, &hdi);

	strRes = GetResString(IDS_FILE);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(1, &hdi);

	strRes = GetResString(IDS_DL_SPEED);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(2, &hdi);

	strRes = GetResString(IDS_DL_TRANSF);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(3, &hdi);

	strRes = GetResString(IDS_WAITED);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(4, &hdi);

	strRes = GetResString(IDS_UPLOADTIME);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(5, &hdi);

	strRes = GetResString(IDS_STATUS);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(6, &hdi);

	strRes = GetResString(IDS_UPSTATUS);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(7, &hdi);

	strRes = GetResString(IDS_UPSLOTNUMBER);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(8, &hdi);

	strRes = GetResString(IDS_SOFTWARE_LABEL);;
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(9, &hdi);

	strRes = GetResString(IDS_MODVERSION_LABEL);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(10, &hdi);

	//MORPH START - Added by SiRoB, Display current uploading chunk
	strRes = GetResString(IDS_CHUNK);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(11, &hdi);
	//MORPH START - Added by SiRoB, Display current uploading chunk

	// <CB Mod : UploadListInfo>
#ifdef CB_MOD_EXTRAINFO_ENABLED
	strRes = GetResString(IDS_DL_SIZE);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(12, &hdi);

	strRes = GetResString(IDS_IPNUMBER);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(13, &hdi);
#endif
	// </CB Mod : UploadListInfo>

}

void CUploadListCtrl::AddClient(const CUpDownClient* client)
{
	if (!theApp.emuledlg->IsRunning())
		return;

	int iItemCount = GetItemCount();
	int iItem = InsertItem(LVIF_TEXT|LVIF_PARAM,iItemCount,LPSTR_TEXTCALLBACK,0,0,0,(LPARAM)client);
	Update(iItem);
	theApp.emuledlg->transferwnd->UpdateListCount(CTransferWnd::wnd2Uploading, iItemCount+1);
}

void CUploadListCtrl::RemoveClient(const CUpDownClient* client)
{
	if (!theApp.emuledlg->IsRunning())
		return;

	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	int result = FindItem(&find);
	if (result != -1) {
		DeleteItem(result);
		theApp.emuledlg->transferwnd->UpdateListCount(CTransferWnd::wnd2Uploading);
	}
}

void CUploadListCtrl::RefreshClient(const CUpDownClient* client)
{
	// There is some type of timing issue here.. If you click on item in the queue or upload and leave
	// the focus on it when you exit the cient, it breaks on line 854 of emuleDlg.cpp
	// I added this IsRunning() check to this function and the DrawItem method and
	// this seems to keep it from crashing. This is not the fix but a patch until
	// someone points out what is going wrong.. Also, it will still assert in debug mode..
	if (!theApp.emuledlg->IsRunning())
		return;

	// <CB Mod : Optimization : by SiroB>
#ifdef CB_MOD_OPTIMIZATIONS_ENABLED
	if( theApp.emuledlg->activewnd != theApp.emuledlg->transferwnd || theApp.emuledlg->transferwnd->uploadlistctrl.IsWindowVisible() == false )
		return;
#endif
	// </CB Mod : Optimization : by SiroB>

	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	int result = FindItem(&find);
	if (result != -1)
		Update(result);
}

#define DLC_DT_TEXT (DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS)

void CUploadListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	if (!theApp.emuledlg->IsRunning())
		return;
	if (!lpDrawItemStruct->itemData)
		return;
	
	// <CB Mod : Optimization : by SiroB>
#ifdef CB_MOD_OPTIMIZATIONS_ENABLED
	RECT clientRect;
	GetClientRect(&clientRect);
	CRect cur_rec = lpDrawItemStruct->rcItem;
	if (cur_rec.top >= clientRect.bottom || cur_rec.bottom <= clientRect.top)
		return;
#endif
	// </CB Mod : Optimization : by SiroB>

	// <CB Mod : UploadList : Colours>
#if defined(CB_MOD_ENHANCEDINTERFACE_ENABLED) && defined(CB_MOD_NEWPRIORITIES_ENABLED)
	BOOL bCtrlFocused = ((GetFocus() == this ) || (GetStyle() & LVS_SHOWSELALWAYS));
	CUpDownClient* client = (CUpDownClient*)lpDrawItemStruct->itemData;
	CKnownFile* file = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
		
	// WARNING: need to check for file validity as it may not be valid once unshared bringing to crashes
	// Change background color for powershared files
	COLORREF lineBackColor = m_crWindow;
	if( (lpDrawItemStruct->itemAction | ODA_SELECT) && (lpDrawItemStruct->itemState & ODS_SELECTED )){
		// Item selected
		if (file) {
			if(bCtrlFocused) { // If the window is focused darker colours are chosen
				if (client->IsFriend() && client->GetFriendSlot())
					lineBackColor = RGB(140,255,140);
				else if (file->GetPowerShared()) 
					lineBackColor = POWERSHARED_BACK_SELECTED;
				else if (file->IsSuperRelease())
					lineBackColor = SUPERRELEASE_BACK_SELECTED;
				else if (thePrefs.SmallFilePush() && file->IsSFP())
					lineBackColor = SMALLPUSHED_BACK_SELECTED;
				else // original
					lineBackColor = m_crHighlight;
			} else { // Window not on focus, slightly lighter colours
				if (client->IsFriend() && client->GetFriendSlot())
					lineBackColor = RGB(225,250,225);
				else if (file->GetPowerShared()) 
					lineBackColor = POWERSHARED_BACK_SELECTED_UF;
				else if (file->IsSuperRelease())
					lineBackColor = SUPERRELEASE_BACK_SELECTED_UF;
				else if (thePrefs.SmallFilePush() && file->IsSFP())
					lineBackColor = SMALLPUSHED_BACK_SELECTED_UF;
				else
					lineBackColor = m_crNoHighlight;
			}
		} else
			lineBackColor = m_crHighlight; // original & default
	} else { // Item not selected
		if (file) {
			if (client->IsFriend() && client->GetFriendSlot())
				lineBackColor = RGB(200,255,200);
			else if (file->GetPowerShared())
				lineBackColor = POWERSHARED_BACK_NORMAL;
			else if (file->IsSuperRelease())
					lineBackColor = SUPERRELEASE_BACK_NORMAL;
			else if (thePrefs.SmallFilePush() && file->IsSFP())
				lineBackColor = SMALLPUSHED_BACK_NORMAL; 
			else // original & default
				lineBackColor = GetBkColor();
		} else
			lineBackColor = m_crNoHighlight; // original & default
	}
	odc->SetBkColor(lineBackColor);
	
	COLORREF crOldBackColor = odc->GetBkColor(); // CB Optimization : by Xman

	CMemDC dc(CDC::FromHandle(lpDrawItemStruct->hDC), &lpDrawItemStruct->rcItem);
	CFont* pOldFont = dc.SelectObject(GetFont());
	COLORREF crOldTextColor = odc->SetTextColor(m_crWindowText);
	//RECT cur_rec = lpDrawItemStruct->rcItem;
	
	
#else	
	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	BOOL bCtrlFocused = ((GetFocus() == this) || (GetStyle() & LVS_SHOWSELALWAYS));
	if (lpDrawItemStruct->itemState & ODS_SELECTED) {
		if (bCtrlFocused)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);
	}
	else
		odc->SetBkColor(GetBkColor());
	const CUpDownClient* client = (CUpDownClient*)lpDrawItemStruct->itemData;
	CMemDC dc(odc, &lpDrawItemStruct->rcItem);
	CFont* pOldFont = dc.SelectObject(GetFont());
	CRect cur_rec(lpDrawItemStruct->rcItem);
	COLORREF crOldTextColor = dc.SetTextColor((lpDrawItemStruct->itemState & ODS_SELECTED) ? m_crHighlightText : m_crWindowText);

#endif
	// </CB Mod : UploadList : Colours>

    if(client->IsScheduledForRemoval()) {
      if(client->GetSlotNumber() > theApp.uploadqueue->GetActiveUploadsCount()) {
		dc.SetTextColor(RGB(255,170,170));
      } else {
		dc.SetTextColor(RGB(255,50,50));
      }
    } else if (client->GetSlotNumber() > theApp.uploadqueue->GetActiveUploadsCount()) {
        dc.SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
    }

	int iOldBkMode;
	if (m_crWindowTextBk == CLR_NONE){
		DefWindowProc(WM_ERASEBKGND, (WPARAM)(HDC)dc, 0);
		iOldBkMode = dc.SetBkMode(TRANSPARENT);
	}
	else
		iOldBkMode = OPAQUE;

	// <CB Mod : UploadList : Colours>
	// Moved above
#if !defined(CB_MOD_ENHANCEDINTERFACE_ENABLED) || !defined(CB_MOD_NEWPRIORITIES_ENABLED)
	CKnownFile* file = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
#endif
	// </CB Mod : UploadList : Colours>
	CHeaderCtrl *pHeaderCtrl = GetHeaderCtrl();
	int iCount = pHeaderCtrl->GetItemCount();
	cur_rec.right = cur_rec.left - 8;
	cur_rec.left += 4;
	CString buffer;

	// <CB MOd : CreditSystem>
	float clientrating = 0;
	// </CB MOd : CreditSystem>

	for (int iCurrent = 0; iCurrent < iCount; iCurrent++)
	{
		int iColumn = pHeaderCtrl->OrderToIndex(iCurrent);
		if (!IsColumnHidden(iColumn))
		{
			cur_rec.right += GetColumnWidth(iColumn);
			switch (iColumn)
			{
				case 0:{
					uint8 image;
					// <CB Mod : CreditSystem>
#ifdef CB_MOD_FINECS_ENABLED
					clientrating = client->credits->GetScoreRatio(client->GetIP(), client);
#else
					clientrating = client->credits->GetScoreRatio(client->GetIP());
#endif
					// </CB Mod : CreditSystem>

					if (client->IsFriend())
						image = 4;
					else if (client->GetClientSoft() == SO_EDONKEYHYBRID){
						// <CB Mod : CreditSystem>
						if ( clientrating > 1)
						// </CB Mod : CreditSystem>
							image = 8;
						else
							image = 7;
					}
					else if (client->GetClientSoft() == SO_MLDONKEY){
						// <CB Mod : CreditSystem>
						if ( clientrating > 1)
						// </CB Mod : CreditSystem>
							image = 6;
						else
							image = 5;
					}
					else if (client->GetClientSoft() == SO_SHAREAZA){
						// <CB Mod : CreditSystem>
						if ( clientrating > 1)
						// </CB Mod : CreditSystem>
							image = 10;
						else
							image = 9;
					}
					else if (client->GetClientSoft() == SO_AMULE){
						// <CB Mod : CreditSystem>
						if ( clientrating > 1)
						// </CB Mod : CreditSystem>
							image = 12;
						else
							image = 11;
					}
					else if (client->GetClientSoft() == SO_LPHANT){
						// <CB Mod : CreditSystem>
						if ( clientrating > 1)
						// </CB Mod : CreditSystem>
							image = 14;
						else
							image = 13;
					}
					else if (client->ExtProtocolAvailable()){
						// <CB Mod : CreditSystem>
						if ( clientrating > 1)
						// </CB Mod : CreditSystem>
							image = 3;
						else
							image = 1;
					}
					else{
						// <CB Mod : CreditSystem>
						if ( clientrating > 1)
						// </CB Mod : CreditSystem>
							image = 2;
						else
							image = 0;
					}

					uint32 nOverlayImage = 0;
					if ((client->Credits() && client->Credits()->GetCurrentIdentState(client->GetIP()) == IS_IDENTIFIED))
						nOverlayImage |= 1;
					if (client->IsObfuscatedConnectionEstablished())
						nOverlayImage |= 2;
					int iIconPosY = (cur_rec.Height() > 16) ? ((cur_rec.Height() - 16) / 2) : 1;
					POINT point = {cur_rec.left, cur_rec.top + iIconPosY};
					imagelist.Draw(dc,image, point, ILD_NORMAL | INDEXTOOVERLAYMASK(nOverlayImage));

					buffer = client->GetUserName();
					cur_rec.left += 20;
					dc.DrawText(buffer, buffer.GetLength(), &cur_rec, DLC_DT_TEXT);
					cur_rec.left -= 20;
					break;
				}

				case 1:
					if (file)
						buffer = file->GetFileName();
					else
						buffer = _T("?");
					break;
				case 2:
                    if(client->GetDatarate() >= 0 && client->socket != NULL) {
						buffer = CastItoXBytes((uint32)client->GetDatarate(), false, true);
					} else {
						buffer.Format(_T("?? %s"),GetResString(IDS_KBYTESPERSEC));
					}
					break;
				case 3:
					// NOTE: If you change (add/remove) anything which is displayed here, update also the sorting part..
					if(client->GetSessionUp() == client->GetQueueSessionUp())
						buffer.Format( _T("%s (%s)"), CastItoXBytes(client->GetSessionUp(), false, false), CastItoXBytes(client->GetQueueSessionPayloadUp(), false, false));
					else
						buffer.Format(_T("%s+%s=%s (%s)"), CastItoXBytes(client->GetSessionUp()), CastItoXBytes(client->GetQueueSessionUp()-client->GetSessionUp()), CastItoXBytes(client->GetQueueSessionUp()), CastItoXBytes(client->GetQueueSessionPayloadUp()));
					break;

				case 4:
					if (client->HasLowID())
						if(client->m_dwWouldHaveGottenUploadSlotIfNotLowIdTick)
							buffer.Format(_T("%s (%s %s)"),CastSecondsToHM((client->GetWaitTime())/1000),GetResString(IDS_IDLOW), CastSecondsToHM((::GetTickCount()-client->GetUpStartTimeDelay()-client->m_dwWouldHaveGottenUploadSlotIfNotLowIdTick)/1000));
						else
							buffer.Format(_T("%s (%s)"),CastSecondsToHM((client->GetWaitTime())/1000),GetResString(IDS_IDLOW) );
					else
						buffer = CastSecondsToHM(client->GetWaitTime()/1000);
					break;

				case 5:
					buffer = CastSecondsToHM(client->GetUpStartTimeDelay()/1000);
					break;

				case 6:
					buffer = client->GetUploadStateDisplayString();
					break;

				case 7:
					cur_rec.bottom--;
					cur_rec.top++;
					client->DrawUpStatusBar(dc, &cur_rec, false, thePrefs.UseFlatBar());
					cur_rec.bottom++;
					cur_rec.top--;
					break;
				case 8:
					buffer.Format(_T("%i"), client->GetSlotNumber());
					break;
				case 9:
					buffer = client->GetClientSoftVer();
					break;
				case 10:
					buffer = client->GetClientModVer();
					break;

				// Display current uploading chunk
				case 11:
					cur_rec.bottom--;
					cur_rec.top++;
					client->DrawUpStatusBarChunk(dc,&cur_rec,false,thePrefs.UseFlatBar());
					cur_rec.bottom++;
					cur_rec.top--;
				break;

				// <CB Mod : UploadListInfo>
#ifdef CB_MOD_EXTRAINFO_ENABLED
				case 12:
					if(file) {
						buffer = CastItoXBytes(file->GetFileSize(), false, false);
						dc->DrawText(buffer, buffer.GetLength(), &cur_rec, DLC_DT_TEXT|DT_RIGHT);
					}
					break;

				case 13:
					buffer = ipstr (client->GetIP());
					break;

				case 14:
					CString temp;
					if (file) {
						if (!client->GetFriendSlot())
							buffer.Format(_T("R: %u"), client->GetScore(false,false,true));
						else
							buffer.Format(_T("%s"), GetResString(IDS_FRIENDDETAIL));
						if (client->credits) {
							if (client->credits->GetUploadedTotal() >= client->credits->GetDownloadedTotal())
								buffer.AppendFormat(_T("  (%s: %s)"), GetResString(IDS_DIFFERENCE_SHORT), CastItoXBytes(client->credits->GetUploadedTotal() - client->credits->GetDownloadedTotal(), false, false));
							else
								buffer.AppendFormat(_T("  (%s: -%s)"), GetResString(IDS_DIFFERENCE_SHORT), CastItoXBytes(client->credits->GetDownloadedTotal() - client->credits->GetUploadedTotal(), false, false));
						}

#ifdef CB_MOD_NEWPRIORITIES_ENABLED
						if (file->IsSuperRelease()) {
							temp.Format (_T("/[P: %s]"), GetResString(IDS_SUPERREL_PREFIX));
						} else {
							temp.Format (_T("/[P: %i]"),  file->GetUpPriority());
							if (file->IsAutoUpPriority()) {
								temp.Append (_T(" "));
								temp.Append (GetResString(IDS_PRIOAUTO));
							}
							if (file->GetPowerShared()) {
								temp.Append (_T(" "));
								temp.Append (GetResString(IDS_POWERSHARE_PREFIX));
							}
						}
						buffer.Append(temp);
#endif
					}
					break;
#endif
					// </CB Mod : UploadListInfo>

			}
			
			// <CB Mod : UploadListInfo>
#ifdef CB_MOD_EXTRAINFO_ENABLED
			if( iColumn != 7 && iColumn != 0 && iColumn != 11 && iColumn != 12)
				dc->DrawText(buffer, buffer.GetLength(), &cur_rec, DLC_DT_TEXT);
#else
			if (iColumn != 7 && iColumn != 0 && iColumn != 11)
				dc.DrawText(buffer, buffer.GetLength(), &cur_rec, DLC_DT_TEXT);
#endif
			// </CB Mod : UploadListInfo>
			
			// <CB Mod : Optimization : By Xman>
#if defined(CB_MOD_ENHANCEDINTERFACE_ENABLED) && defined(CB_MOD_NEWPRIORITIES_ENABLED)
			dc.SetBkColor(crOldBackColor);
#endif
			// </CB Mod : Optimization : By Xman>
			
			cur_rec.left += GetColumnWidth(iColumn);
		}
	}

	//draw rectangle around selected item(s)
	if (lpDrawItemStruct->itemState & ODS_SELECTED)
	{
		RECT outline_rec = lpDrawItemStruct->rcItem;

		outline_rec.top--;
		outline_rec.bottom++;
		dc.FrameRect(&outline_rec, &CBrush(GetBkColor()));
		outline_rec.top++;
		outline_rec.bottom--;
		outline_rec.left++;
		outline_rec.right--;

		if (bCtrlFocused)
			dc.FrameRect(&outline_rec, &CBrush(m_crFocusLine));
		else
			dc.FrameRect(&outline_rec, &CBrush(m_crNoFocusLine));
	}

	if (m_crWindowTextBk == CLR_NONE)
		dc.SetBkMode(iOldBkMode);
	dc.SelectObject(pOldFont);
	dc.SetTextColor(crOldTextColor);
}

void CUploadListCtrl::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	const CUpDownClient* client = (iSel != -1) ? (CUpDownClient*)GetItemData(iSel) : NULL;

	CTitleMenu ClientMenu;
	ClientMenu.CreatePopupMenu();
	ClientMenu.AddMenuTitle(GetResString(IDS_CLIENTS), true);
	ClientMenu.AppendMenu(MF_STRING | (client ? MF_ENABLED : MF_GRAYED), MP_DETAIL, GetResString(IDS_SHOWDETAILS), _T("CLIENTDETAILS"));
	ClientMenu.SetDefaultItem(MP_DETAIL);
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && !client->IsFriend()) ? MF_ENABLED : MF_GRAYED), MP_ADDFRIEND, GetResString(IDS_ADDFRIEND), _T("ADDFRIEND"));
	
	// <CB Mod : Friend Management : Easy Remove>
#ifdef CB_MOD_EASYFRIENDSLOT_ENABLED
	ClientMenu.AppendMenu(MF_STRING | (client && client->IsFriend() ? MF_ENABLED : MF_GRAYED), MP_REMOVEFRIEND, GetResString(IDS_REMOVEFRIEND), _T("DELETEFRIEND"));
#endif
	// </CB Mod : Friend Management : Easy Remove>
	
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient()) ? MF_ENABLED : MF_GRAYED), MP_MESSAGE, GetResString(IDS_SEND_MSG), _T("SENDMESSAGE"));
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && client->GetViewSharedFilesSupport()) ? MF_ENABLED : MF_GRAYED), MP_SHOWLIST, GetResString(IDS_VIEWFILES), _T("VIEWFILES"));
	if (Kademlia::CKademlia::IsRunning() && !Kademlia::CKademlia::IsConnected())
		ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && client->GetKadPort()!=0) ? MF_ENABLED : MF_GRAYED), MP_BOOT, GetResString(IDS_BOOTSTRAP));
	ClientMenu.AppendMenu(MF_STRING | (GetItemCount() > 0 ? MF_ENABLED : MF_GRAYED), MP_FIND, GetResString(IDS_FIND), _T("Search"));

	// <CB Mod : Friend Management : Easy FriendSlot>
#ifdef CB_MOD_EASYFRIENDSLOT_ENABLED
	ClientMenu.AppendMenu(MF_SEPARATOR);
	ClientMenu.AppendMenu(MF_STRING, MP_FRIENDSLOT, GetResString(IDS_FRIENDSLOT), _T("FRIENDSLOT"));
	ClientMenu.EnableMenuItem(MP_FRIENDSLOT, (client)?MF_ENABLED:MF_GRAYED);
	ClientMenu.CheckMenuItem(MP_FRIENDSLOT, (client)? client->GetFriendSlot()? MF_CHECKED : MF_UNCHECKED : MF_GRAYED);
#endif
	// </CB Mod : Friend Management : Easy FriendSlot>

	// <CB Mod : ForceCheck>
#if defined(CB_MOD_ILLEGALMODSFILTER_ENABLED) && defined(_DEBUG)
	ClientMenu.AppendMenu(MF_SEPARATOR);
	ClientMenu.AppendMenu(MF_STRING, MP_FORCECLIENTCHECK, _T("Force Check"), NULL);
#endif
	// </CB Mod : ForceCheck>

	GetPopupMenuPos(*this, point);
	ClientMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
}

BOOL CUploadListCtrl::OnCommand(WPARAM wParam, LPARAM /*lParam*/)
{
	wParam = LOWORD(wParam);

	switch (wParam)
	{
		case MP_FIND:
			OnFindStart();
			return TRUE;
	}

	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	if (iSel != -1){
		CUpDownClient* client = (CUpDownClient*)GetItemData(iSel);

		// <CB Mod : ContextMenu>
		// It may happen that the client is removed from the queue when the a selection has been done
#ifdef CB_MOD_GENERALFIXES_ENABLED
		if (!client)
			return true;
#endif
		// </CB Mod : ContextMenu>

		switch (wParam){
			case MP_SHOWLIST:
				client->RequestSharedFileList();
				break;
			case MP_MESSAGE:
				theApp.emuledlg->chatwnd->StartSession(client);
				break;
			case MP_ADDFRIEND:
				if (theApp.friendlist->AddFriend(client))
					Update(iSel);
				break;
			case MP_DETAIL:
			case MPG_ALTENTER:
			case IDA_ENTER:
			{
				CClientDetailDialog dialog(client, this);
				dialog.DoModal();
				break;
			}
			case MP_BOOT:
				if (client->GetKadPort())
					Kademlia::CKademlia::Bootstrap(ntohl(client->GetIP()), client->GetKadPort(), (client->GetKadVersion() > 1));
				break;
		
			// <CB Mod : Friend Management : Easy FriendSlot>
#ifdef CB_MOD_EASYFRIENDSLOT_ENABLED
			case MP_FRIENDSLOT:
				theApp.friendlist->AddFriend(client);
				if (client->GetFriendSlot())
					client->SetFriendSlot(false);
				else
					client->SetFriendSlot(true);
				Update(iSel);
				break;
			case MP_REMOVEFRIEND:
				if (client && client->IsFriend() && client->m_Friend != NULL) {
					theApp.friendlist->RemoveFriend(client->m_Friend);
					Update(iSel);
				}
				break;
#endif
			// </CB Mod : Friend Management : Easy FriendSlot>
			

			// <CB Mod : ForceCheck>
#if defined(CB_MOD_ILLEGALMODSFILTER_ENABLED) && defined(_DEBUG)
			case MP_FORCECLIENTCHECK:
				client->CheckForGPLEvilDoer();
				break;
#endif
			// </CB Mod : ForceCheck>
		}
	}
	return true;
}


void CUploadListCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult){

	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// if it's a second click on the same column then reverse the sort order,
	// otherwise sort the new column in ascending order.

	// Barry - Store sort order in preferences
	// Determine ascending based on whether already sorted on this column
	bool sortAscending = (GetSortItem() != pNMListView->iSubItem) ? true : !GetSortAscending();

		// <CB Mod : 4-way sorting : Date 11.07.07>>
#ifdef CB_MOD_EXTRAINFO_ENABLED
	int adder=0;
	int index = pNMListView->iSubItem - 14;
	if (pNMListView->iSubItem==14) {
		ASSERT( index < ARRSIZE(sortstat) );
		if (!sortAscending)
			sortstat[index] = !sortstat[index];
		adder = sortstat[index] ? 0 : 50;
	}

	// Sort table
	UpdateSortHistory(pNMListView->iSubItem + adder + (sortAscending ? 0:100), 100);
	if (adder==0)	
		SetSortArrow(pNMListView->iSubItem, sortAscending); 
	else
		SetSortArrow(pNMListView->iSubItem, sortAscending ? arrowDoubleUp : arrowDoubleDown);
	SortItems(SortProc, pNMListView->iSubItem + adder + (sortAscending ? 0:100));

#else
	// Sort table
	UpdateSortHistory(pNMListView->iSubItem + (sortAscending ? 0:100));
	SetSortArrow(pNMListView->iSubItem, sortAscending);
	SortItems(SortProc, pNMListView->iSubItem + (sortAscending ? 0:100));
#endif

	*pResult = 0;
}

int CUploadListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	const CUpDownClient* item1 = (CUpDownClient*)lParam1;
	const CUpDownClient* item2 = (CUpDownClient*)lParam2;

	int iResult=0;
	switch(lParamSort){
		case 0: 
			if(item1->GetUserName() && item2->GetUserName())
				iResult=CompareLocaleStringNoCase(item1->GetUserName(), item2->GetUserName());
			else if(item1->GetUserName())
				iResult=1;
			else
				iResult=-1;
			break;
		case 100:
			if(item1->GetUserName() && item2->GetUserName())
				iResult=CompareLocaleStringNoCase(item2->GetUserName(), item1->GetUserName());
			else if(item2->GetUserName())
				iResult=1;
			else
				iResult=-1;
			break;
		case 1: {
			CKnownFile* file1 = theApp.sharedfiles->GetFileByID(item1->GetUploadFileID());
			CKnownFile* file2 = theApp.sharedfiles->GetFileByID(item2->GetUploadFileID());
			if( (file1 != NULL) && (file2 != NULL))
				iResult=CompareLocaleStringNoCase(file1->GetFileName(), file2->GetFileName());
			else if( file1 == NULL )
				iResult=1;
			else
				iResult=-1;
			break;
		}
		case 101:{
			CKnownFile* file1 = theApp.sharedfiles->GetFileByID(item1->GetUploadFileID());
			CKnownFile* file2 = theApp.sharedfiles->GetFileByID(item2->GetUploadFileID());
			if( (file1 != NULL) && (file2 != NULL))
				iResult=CompareLocaleStringNoCase(file2->GetFileName(), file1->GetFileName());
			else if( file1 == NULL )
				iResult=1;
			else
				iResult=-1;
			break;
		}
		case 2: 
			iResult=CompareUnsigned(item1->GetDatarate(), item2->GetDatarate());
			break;
		case 102:
			iResult=CompareUnsigned(item2->GetDatarate(), item1->GetDatarate());
			break;

		case 3: 
			iResult=CompareUnsigned(item1->GetSessionUp(), item2->GetSessionUp());
			if (iResult == 0 && thePrefs.m_bExtControls) {
				iResult = CompareUnsigned(item1->GetQueueSessionPayloadUp(), item2->GetQueueSessionPayloadUp());
			}
			break;
		case 103: 
			iResult=CompareUnsigned(item2->GetSessionUp(), item1->GetSessionUp());
			if (iResult == 0 && thePrefs.m_bExtControls) {
				iResult = CompareUnsigned(item2->GetQueueSessionPayloadUp(), item1->GetQueueSessionPayloadUp());
			}
			break;

		case 4: 
			iResult=item1->GetWaitTime() - item2->GetWaitTime();
			break;
		case 104: 
			iResult=item2->GetWaitTime() - item1->GetWaitTime();
			break;

		case 5: 
			iResult=item1->GetUpStartTimeDelay() - item2->GetUpStartTimeDelay();
			break;
		case 105: 
			iResult=item2->GetUpStartTimeDelay() - item1->GetUpStartTimeDelay();
			break;

		case 6: 
			iResult=item1->GetUploadState() - item2->GetUploadState();
			break;
		case 106: 
			iResult=item2->GetUploadState() - item1->GetUploadState();
			break;

		case 7:
			iResult=item1->GetUpPartCount() - item2->GetUpPartCount();
			break;
		case 107: 
			iResult=item2->GetUpPartCount() - item1->GetUpPartCount();
			break;

        case 8:
			iResult=CompareUnsigned(item1->GetSlotNumber(), item2->GetSlotNumber());
            break;
        case 108:
			iResult=CompareUnsigned(item2->GetSlotNumber(), item1->GetSlotNumber());
            break;

        case 9:
		case 109: 
			if(item1->GetClientSoftVer().IsEmpty() && item2->GetClientSoftVer().IsEmpty()) {
				iResult = _tcsicmp(item1->GetClientSoftVer(), item2->GetClientSoftVer());
				if(lParamSort == 109) {
					iResult = -iResult;
				}
			} else if(item1->GetClientSoftVer().IsEmpty())
				iResult =  1;
			else
				iResult =  -1;
			break;

		case 10:
		case 110: 
			if(item1->GetClientModVer().IsEmpty() && item2->GetClientModVer().IsEmpty()) {
				iResult = _tcsicmp(item1->GetClientModVer(), item2->GetClientModVer());
					if(lParamSort == 110) {
					iResult = -iResult;
				}
			} else
				if (item1->GetClientModVer().IsEmpty())
					iResult =  1;
				else if (item2->GetClientModVer().IsEmpty())
					iResult =  -1;
				else
					iResult = 0; // keep peers sorted as for latest sort critera					
			break;

		// <CB Mod : UploadListInfo : Sort>
#ifdef CB_MOD_EXTRAINFO_ENABLED
		case 12:
		{
			CKnownFile *file1 = theApp.sharedfiles->GetFileByID(item1->GetUploadFileID());
			CKnownFile *file2 = theApp.sharedfiles->GetFileByID(item2->GetUploadFileID());
			if( (file1 != NULL) && (file2 != NULL))
				return CompareUnsigned64((uint64)file1->GetFileSize(), (uint64)file2->GetFileSize());
		}
		break;

		case 112:
		{
			CKnownFile *file1 = theApp.sharedfiles->GetFileByID(item1->GetUploadFileID());
			CKnownFile *file2 = theApp.sharedfiles->GetFileByID(item2->GetUploadFileID());
			if( (file1 != NULL) && (file2 != NULL))
				return CompareUnsigned64((uint64)file2->GetFileSize(), (uint64)file1->GetFileSize());
		}
		break;

		case 13:
		{
			uint32 ip1 = ntohl(item1->GetIP());
			uint32 ip2 = ntohl(item2->GetIP());
			if(ip1 > ip2)
				return 1;
			else if (ip1 < ip2)
				return -1;
			else
				return 0;
		}
		break;

		case 113:
		{
			uint32 ip1 = ntohl(item1->GetIP());
			uint32 ip2 = ntohl(item2->GetIP());
			if(ip1 > ip2)
				return -1;
			else if (ip1 < ip2)
				return 1;
			else
				return 0;
		}
		break;

		case 14:
			case 114:
			if (item1->GetScore(false,false,true) > item2->GetScore(false,false,true))
				iResult = 1;
			else if (item1->GetScore(false,false,true) < item2->GetScore(false,false,true))
				iResult = -1;
			else
				iResult = 0;

			if (lParamSort == 114)
				iResult = -iResult;
			break;

		case 64:
		case 164:
		{
			sint64 diff1 = item1->credits->GetUploadedTotal()-item1->credits->GetDownloadedTotal();
			sint64 diff2 = item2->credits->GetUploadedTotal()-item2->credits->GetDownloadedTotal();
			iResult = 0;
			if (item1->credits && item2->credits) {
				if (diff1 > diff2)
					iResult = 1;
				else if (diff1 < diff2)
					iResult = -1;
			}
			if (lParamSort == 164)
				iResult = -iResult;
		}
		break;

#endif
		// </CB Mod : UploadListInfo : Sort>

		default:
			iResult=0;
			break;
	}
	int dwNextSort;
	//call secondary sortorder, if this one results in equal
	//(Note: yes I know this call is evil OO wise, but better than changing a lot more code, while we have only one instance anyway - might be fixed later)
	if (iResult == 0 && (dwNextSort = theApp.emuledlg->transferwnd->uploadlistctrl.GetNextSortOrder(lParamSort)) != (-1)){
		iResult= SortProc(lParam1, lParam2, dwNextSort);
	}

	return iResult;

}

void CUploadListCtrl::ShowSelectedUserDetails()
{
	POINT point;
	::GetCursorPos(&point);
	CPoint p = point; 
    ScreenToClient(&p); 
    int it = HitTest(p); 
    if (it == -1)
		return;

	SetItemState(-1, 0, LVIS_SELECTED);
	SetItemState(it, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
	SetSelectionMark(it);   // display selection mark correctly!

	CUpDownClient* client = (CUpDownClient*)GetItemData(GetSelectionMark());
	if (client){
		CClientDetailDialog dialog(client, this);
		dialog.DoModal();
	}
}

void CUploadListCtrl::OnNMDblclk(NMHDR* /*pNMHDR*/, LRESULT* pResult)
{
	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	if (iSel != -1){
		CUpDownClient* client = (CUpDownClient*)GetItemData(iSel);
		if (client){
			CClientDetailDialog dialog(client, this);
			dialog.DoModal();
		}
	}
	*pResult = 0;
}

void CUploadListCtrl::OnGetDispInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (theApp.emuledlg->IsRunning()){
		// Although we have an owner drawn listview control we store the text for the primary item in the listview, to be
		// capable of quick searching those items via the keyboard. Because our listview items may change their contents,
		// we do this via a text callback function. The listview control will send us the LVN_DISPINFO notification if
		// it needs to know the contents of the primary item.
		//
		// But, the listview control sends this notification all the time, even if we do not search for an item. At least
		// this notification is only sent for the visible items and not for all items in the list. Though, because this
		// function is invoked *very* often, no *NOT* put any time consuming code here in.

		if (pDispInfo->item.mask & LVIF_TEXT){
			const CUpDownClient* pClient = reinterpret_cast<CUpDownClient*>(pDispInfo->item.lParam);
			if (pClient != NULL){
				switch (pDispInfo->item.iSubItem){
					case 0:
						if (pClient->GetUserName() && pDispInfo->item.cchTextMax > 0){
							_tcsncpy(pDispInfo->item.pszText, pClient->GetUserName(), pDispInfo->item.cchTextMax);
							pDispInfo->item.pszText[pDispInfo->item.cchTextMax-1] = _T('\0');
						}
						break;
					default:
						// shouldn't happen
						pDispInfo->item.pszText[0] = _T('\0');
						break;
				}
			}
		}
	}
	*pResult = 0;
}

void CUploadListCtrl::OnLvnGetInfoTip(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVGETINFOTIP pGetInfoTip = reinterpret_cast<LPNMLVGETINFOTIP>(pNMHDR);
	if (pGetInfoTip->iSubItem == 0)
	{
		LVHITTESTINFO hti = {0};
		::GetCursorPos(&hti.pt);
		ScreenToClient(&hti.pt);
		if (SubItemHitTest(&hti) == -1 || hti.iItem != pGetInfoTip->iItem || hti.iSubItem != 0){
			// don't show the default label tip for the main item, if the mouse is not over the main item
			if ((pGetInfoTip->dwFlags & LVGIT_UNFOLDED) == 0 && pGetInfoTip->cchTextMax > 0 && pGetInfoTip->pszText[0] != _T('\0'))
				pGetInfoTip->pszText[0] = _T('\0');
			return;
		}

		const CUpDownClient* client = (CUpDownClient*)GetItemData(pGetInfoTip->iItem);
		if (client && pGetInfoTip->pszText && pGetInfoTip->cchTextMax > 0)
		{
			CString strInfo;
			strInfo.Format(GetResString(IDS_USERINFO), client->GetUserName());
			const CKnownFile* file = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
			if (file)
			{
				strInfo += GetResString(IDS_SF_REQUESTED) + _T(' ') + file->GetFileName() + _T('\n');
				strInfo.AppendFormat(GetResString(IDS_FILESTATS_SESSION) + GetResString(IDS_FILESTATS_TOTAL),
					file->statistic.GetAccepts(), file->statistic.GetRequests(), CastItoXBytes(file->statistic.GetTransferred(), false, false),
					file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), CastItoXBytes(file->statistic.GetAllTimeTransferred(), false, false));
			}
			else
			{
				strInfo += GetResString(IDS_REQ_UNKNOWNFILE);
			}
			strInfo += TOOLTIP_AUTOFORMAT_SUFFIX_CH;
			_tcsncpy(pGetInfoTip->pszText, strInfo, pGetInfoTip->cchTextMax);
			pGetInfoTip->pszText[pGetInfoTip->cchTextMax-1] = _T('\0');
		}
	}
	*pResult = 0;
}
